<?php
load_plugin_textdomain('xoogu-dynamic-shortcodes-wpsc', false, dirname(__FILE__).'/lang/');
if (is_network_admin()) {
	$postURL = network_admin_url('settings.php?page=wpsupercache&tab=plugins');
	$network = true;
} else {
	$postURL = get_admin_url(null, 'options-general.php?page=wpsupercache&tab=plugins');
	$network = false;
}
global $wpsc_xds_shortcodes;
//bool whether the settings are to be updated
$bChanged = false;
//var_dump($wpsc_xds_shortcodes, $_POST);
if (isset($_POST['wpsc_xds_shortcodes_submit']) && $GLOBALS['valid_nonce']) {	
	//process POST
	
	//clear all existing shortcodes
	$wpsc_xds_shortcodes_toAdd=array();
	
	//parse any extra shortcodes
	if (!empty($_POST['wpsc_xds_extraShortcodes'])) {
		$aExtraShortcodes = explode(',', $_POST['wpsc_xds_extraShortcodes']);
		foreach ($aExtraShortcodes as $sExtraShortcode) {
			$sExtraShortcode = trim($sExtraShortcode);
			if ($sExtraShortcode && !in_array($sExtraShortcode, $wpsc_xds_shortcodes)) {
				$wpsc_xds_shortcodes_toAdd[] = $sExtraShortcode;
				$bChanged = true;
			}
		}
	}
	
	//Selected shortcodes
	if (!empty($_POST['wpsc_xds_shortcodes'])) {
		foreach ($_POST['wpsc_xds_shortcodes'] as $shortcode => $checked) {
			$wpsc_xds_shortcodes_toAdd[] = $shortcode;
		}
		$bChanged = true;
	}
	
	//If we had any shortcodes chosen, then update the var that holds the dynamic shortcodes
	if ($bChanged) {
		$wpsc_xds_shortcodes = $wpsc_xds_shortcodes_toAdd;
	}
	//No shortcodes chosen at all
	elseif (!empty($wpsc_xds_shortcodes)) {
		$wpsc_xds_shortcodes=null;
		$bChanged = true;
	}
	
	//If the settings need to be updated, then update them
	if ($bChanged) {
		if (!empty($wpsc_xds_shortcodes)) {
			//wp_cache_replace_line replaces the line if it exists, otherwise it adds the line
			wp_cache_replace_line('^ *\$wpsc_xds_shortcodes =', '$wpsc_xds_shortcodes = array(\''.implode("','", $wpsc_xds_shortcodes)."');", $GLOBALS['wp_cache_config_file']);
			//we have to use a var rather than a constant (define) as otherwise we'll get errors from the cache manager from it checking
			//the config file, unless we wrap the define in an if(defined) block. Easier to just use a var.
			if (empty($GLOBALS['wpsc_xds_secret'])) {
				//if we don't have a secret key up, generate one
				wp_cache_replace_line('^ *\$wpsc_xds_secret', '$wpsc_xds_secret = \''.substr(md5($GLOBALS['valid_nonce']),1,7)."';", $GLOBALS['wp_cache_config_file']);
			}
		} else {
			wp_cache_replace_line('^ *\$wpsc_xds_shortcodes =', null, $GLOBALS['wp_cache_config_file']);
			wp_cache_replace_line('^ *\$wpsc_xds_secret', null, $GLOBALS['wp_cache_config_file']);
		}
	}
}

?><fieldset id="geotarget-section" class="options">
<h4><?php _e('Dynamic Shortcodes', 'xoogu-dynamic-shortcodes-wpsc'); ?></h4>
<form name="wp_manager" action="<?php echo $postURL; ?>" method="post">
<?php
echo '<p>'; _e('The Xoogu Dynamic Shortcodes plugin for WP Super Cache enables you to choose shortcodes that should be processed dynamically on every page load. This can be useful if you have a shortcode that needs to display changing information, such as geo-targeted content, short timescale based content, or visitor specific content.', 'xoogu-dynamic-shortcodes-wpsc'); echo '</p>';
$sDesc = 'This plugin requires that the late init and dynamic caching options of WP Super Cache are enabled. At the moment %s.';

//Check that late init and dynamic caching have been checked
if ( empty($GLOBALS['wp_super_cache_late_init']) || empty($GLOBALS['wp_cache_mfunc_enabled']) ){
	//If the user has enabled this plugin, then disabled late init or dynamic caching, we need to
	//disable this plugin as it won't work
	if (!empty($GLOBALS['wpsc_xds_secret'])) {
		wp_cache_replace_line('^ *\$wpsc_xds_secret', null, $GLOBALS['wp_cache_config_file']);
		wp_cache_replace_line('^ *\$wpsc_xds_shortcodes =', null, $GLOBALS['wp_cache_config_file']);
	}
	
	
	if (empty($GLOBALS['wp_super_cache_late_init']) && empty($GLOBALS['wp_cache_mfunc_enabled'])) {
		$sProblem = __('both late init and dynamic caching are disabled', 'xoogu-dynamic-shortcodes-wpsc');
	} elseif (empty($GLOBALS['wp_super_cache_late_init'])) {
		$sProblem = __('late init is disabled', 'xoogu-dynamic-shortcodes-wpsc');
	} else {
		$sProblem = __('dynamic caching is disabled', 'xoogu-dynamic-shortcodes-wpsc');
	}
	echo '<p>'.sprintf(__($sDesc, 'xoogu-dynamic-shortcodes-wpsc'), $sProblem).__(' Please check the Advanced settings page of the Super Cache settings and enable these options to make use of this plugin.', 'xoogu-dynamic-shortcodes-wpsc').'</p>';
} else {
	echo '<p>'.sprintf(__($sDesc, 'xoogu-dynamic-shortcodes-wpsc'), __('both are enabled, so this plugin will work correctly', 'xoogu-dynamic-shortcodes-wpsc')).'</p>';
	echo '<p>'.__('Please remember that after enabling or disabling any dynamic shortcodes, you will need to clear the cache to remove any existing cached pages containing the shortcodes.', 'xoogu-dynamic-shortcodes-wpsc').'</p>';
	//user inputs list of shortcodes
	//inspect $shortcode_tags to find out what handlers these shortcodes have
	//If can tell ones using a var pointing to obj, wrap in $GLOBALS['objvar']
	//save list as shortcode => handler array in $wpsc_xds_shortcodes
	echo '<p>'.__('Check the shortcodes that should be processed dynamically on every page load:', 'xoogu-dynamic-shortcodes-wpsc').'</p>';
	echo '<ul>';
	$aShortcodes = is_array($wpsc_xds_shortcodes) ? array_flip(array_merge(array_flip(array_keys($GLOBALS['shortcode_tags'])), array_flip($wpsc_xds_shortcodes))) : array_keys($GLOBALS['shortcode_tags']);
	sort($aShortcodes);
	foreach ($aShortcodes as $sShortCode) {
		echo '<li><input type="checkbox" id="xds-'.$sShortCode.'" name="wpsc_xds_shortcodes['.$sShortCode.']"';
		if (!empty($wpsc_xds_shortcodes) && in_array($sShortCode, $wpsc_xds_shortcodes)) {
			echo ' checked="checked"';
		}
		echo ' /><label for="xds-'.$sShortCode.'">'.$sShortCode.'</label></li>';
	}
	echo '</ul>';
	
	//text input for manually entering shortcodes
	echo '<label for="wpsc_xds_extraShortcodes" >'.__('Any shortcodes not listed above you want to add (comma separated)','xoogu-dynamic-shortcodes-wpsc').'</label>';
    echo '<input type="text" value="" id="wpsc_xds_extraShortcodes" name="wpsc_xds_extraShortcodes" />';
	
	//settings updated message
	if (!empty($bChanged)) {
		echo '<p><strong>'. __('Xoogu Dynamic shortcodes Super Cache plugin settings updated.', 'xoogu-dynamic-shortcodes-wpsc').'</strong></p>';
	}
	
	//save button
	echo '<div class="submit"><input class="button-primary" ' . SUBMITDISABLED . 'type="submit" value="' . __( 'Update', 'wp-super-cache' ) . '" name="wpsc_xds_shortcodes_submit" /></div>';
	wp_nonce_field('wp-cache');
}
?>
</form>
</fieldset>